/////////////////////////////////////////////////////////////////////////////
// Name:        _swigtype.i
// Purpose:     stuff to help us debug SWIG's type_info structures...
//
// Author:      Robin Dunn
//
// Created:     19-Jan-2006
// RCS-ID:      $Id$
// Copyright:   (c) 2006 by Total Control Software
// Licence:     wxWindows license
/////////////////////////////////////////////////////////////////////////////

// Not a %module


#if 0  // Only needs to be turned on when debugging SWIG problems

//---------------------------------------------------------------------------
%newgroup

%immutable;

/* Structure to store inforomation on one type */
typedef struct swig_type_info {
  const char             *name;			/* mangled name of this type */
  const char             *str;			/* human readable name of this type */
  swig_dycast_func        dcast;		/* dynamic cast function down a hierarchy */
  struct swig_cast_info  *cast;			/* linked list of types that can cast into this type */
  void                   *clientdata;		/* language specific type data */
} swig_type_info;

/* Structure to store a type and conversion function used for casting */
typedef struct swig_cast_info {
  swig_type_info         *type;			/* pointer to type that is equivalent to this type */
  swig_converter_func     converter;		/* function to cast the void pointers */
  struct swig_cast_info  *next;			/* pointer to next cast in linked list */
  struct swig_cast_info  *prev;			/* pointer to the previous cast */
} swig_cast_info;

%mutable;

swig_type_info* SWIG_TypeQuery(const char* name);

//---------------------------------------------------------------------------

#endif


